/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            Cloner.h                                        //
////////////////////////////////////////////////////////////////////////////////

#ifndef CLONER_H
#define CLONER_H

#include "X3DOnePassProcessor.h"
#include "ClonerStateVariables.h"

namespace X3DTK {

/// Cloner processor.

class Cloner : public X3DOnePassProcessor
{
public:
  /// Constructor.
  Cloner();
  /// Destructor.
  virtual ~Cloner();
  
  /// Clones the sub-tree of which N is the root.
  virtual SFNode clone(SFNode N, bool reset = true) const;

  /// Initializes the traversal. Use it in case of a call to clone with reset set to false.
  void init();
  /// Finishes the traversal. Use it in case of a call to clone with reset set to false.
  void finish();
};

}

#endif
