/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_MESH_NORMALSFLIPPERCOREVISITOR_H
#define X3DTK_MESH_NORMALSFLIPPERCOREVISITOR_H

#include "MESH_NormalsFlipperStateVariables.h"
#include "MESH_CoreVisitor.h"
#include "MESH_Mesh.h"
#include "MESH_SceneGraphTypes.h"

#include <map>

namespace X3DTK {
namespace MESH {

/*! \brief Class declared in <b><X3DTK/MESH/normalsflipper.h></b> providing a visitor of the 
 *  Core component of the MESH::TemplateNormalsFlipper processor.
 *
 *  \ingroup MESH
 */

template<class MData, class VData, class EData, class FData, bool RW>
class TemplateNormalsFlipperCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  TemplateNormalsFlipperCoreVisitor();

  /// Enters a Mesh.
  static void enterVertex(TemplateVertex<MData, VData, EData, FData, RW> *V);
  /// Walks on a Shape.
  static bool walkOnShape(Shape *S, SFNode child);
};

}
}

#include "MESH_NormalsFlipperCoreVisitor.inl"

#endif
