/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3D_COORDMERGERSTATEVARIABLES_H
#define X3DTK_X3D_COORDMERGERSTATEVARIABLES_H

#include "StateVariables.h"

#include <list>
#include <map>
#include <utility>

namespace X3DTK {
namespace X3D {

class IndexedFaceSet;
class Transform;
class Coordinate;

/*! \brief Class declared in <b><X3DTK/X3D/sharedcoordcomputer.h></b> providing StateVariables
 *  for the X3D::CoordMerger processor.
 *
 *  \ingroup X3D
 */

class CoordMergerStateVariables : public StateVariables
{
public:
  /// Constructor.
  CoordMergerStateVariables();
  /// Destructor.
  virtual ~CoordMergerStateVariables();
  
  /// Finishes the traversal.
  virtual void finish();
  
  /// Adds the Coordinate.
  void addNode(Coordinate *C);
  /// Returns true if Coordinate has already been visited.
  bool getNode(Coordinate *C) const;
  
private:  
  std::list<SFNode> _coordinateList;
};

}
}

#endif
