/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3D_MESHBUILDERGEOMETRY3DVISITOR_H
#define X3DTK_X3D_MESHBUILDERGEOMETRY3DVISITOR_H

#include "X3D_Geometry3DVisitor.h"
#include "X3D_MeshBuilderStateVariables.h"
#include "X3D_Coordinate.h"
#include "X3D_Normal.h"
#include "X3D_Color.h"
#include "X3D_ColorRGBA.h"
#include "X3D_TextureCoordinate.h"
#include "X3D_Box.h"
#include "X3D_Cone.h"
#include "X3D_Cylinder.h"
#include "X3D_IndexedFaceSet.h"
#include "X3D_Sphere.h"
#include "MESH_Vertex.h"
#include "MESH_Mesh.h"

#include "TypeList.h"

namespace X3DTK {
namespace X3D {

/*! \brief Class declared in <b><X3DTK/X3D/meshbuilder.h></b> providing a visitor
 *  of the Geometry3D component for the X3D::TemplateMeshBuilder processor.
 *
 *  \ingroup X3D
 */

template<class MData, class VData, class EData, class FData, bool RW>
class TemplateMeshBuilderGeometry3DVisitor : public Geometry3DVisitor
{
public:
  /// Constructor.
  TemplateMeshBuilderGeometry3DVisitor();

  /// Enters an IndexedFaceSet.
  static void enterIndexedFaceSet(IndexedFaceSet *I);
  /// Leaves an IndexedFaceSet.
  static void leaveIndexedFaceSet(IndexedFaceSet *);
};

}
}

#include "X3D_MeshBuilderGeometry3DVisitor.inl"

#endif
