/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3D_X3DNODE_H
#define X3DTK_X3D_X3DNODE_H

#include "X3D_SceneGraphTypes.h"
#include "X3DAbstractNode.h"

namespace X3DTK {

/// namespace including the X3D scene graph as well as its related classes.

namespace X3D {

/*! \brief Base class declared in <b><X3DTK/X3D/scenegraph.h></b>, part of the <a href="../../doc/X3DSpecs/Part01/components/core.html">
 *  Core component</a> defining an X3DNode 
 *  (<a href="../../doc/X3DSpecs/Part01/components/core.html#X3DNode">
 *  documentation</a>) for all nodes in the X3D system.
 *
 *  \ingroup X3DSceneGraph
 */

class X3DNode : public X3DAbstractNode
{
public:
  /// Constructor.
  X3DNode();
  /// Destructor.
  virtual ~X3DNode();
};

}
}

#endif
